Error accessing default template when trying to disable build mode with a normal user

02/24/2016 06:15 AM - Julien Pivotto

Status: New   

Priority: Normal   

Assignee:    

Category: Organizations and Locations   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.10.1

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

$ curl -s -k -u jenkins:pass -H Content-Type:application/json -H Accept:version=2,application/json

 -X PUT -d '{"build":false}' https://foreman.example.lab/api/hosts/fna060.be.example.lab          

                                                                                            

{

  "error": {"id":435,"errors":{"base":["Failed to generate PXELinux template: undefined method `en

coding' for nil:NilClass"]},"full_messages":["Failed to generate PXELinux template: undefined meth

od `encoding' for nil:NilClass"]}

}

Additional infos:

jenkins is a non admin user

'{"build":true}' works to put the host in build mode

At the end the host is still in build mode

It is broken in the webui as well

History

#1 - 02/24/2016 06:15 AM - Julien Pivotto

- File production.log added

- Description updated

#2 - 02/24/2016 06:16 AM - Julien Pivotto

- Description updated

#3 - 02/24/2016 06:18 AM - Julien Pivotto

- Category set to API

#4 - 02/24/2016 06:18 AM - Julien Pivotto

- Description updated

#5 - 02/24/2016 06:20 AM - Julien Pivotto

- Subject changed from Error when trying to disable build mode via the API to Error when trying to disable build mode with a normal user

- Description updated

- Category deleted (API)

#6 - 02/24/2016 06:22 AM - Dominic Cleal

Do you have a template named (precisely) "PXELinux default local boot"?  If using orgs/locs, it may need to be accessible to the jenkins user too.

#7 - 02/24/2016 06:25 AM - Julien Pivotto

Yes.

05/21/2024 1/2



And it is not accessible by that user because not associated with any location/org.

#8 - 02/24/2016 06:26 AM - Dominic Cleal

- Subject changed from Error when trying to disable build mode with a normal user to Error accessing default template when trying to disable build

mode with a normal user

- Category set to Organizations and Locations

#9 - 02/24/2016 06:27 AM - Julien Pivotto

- Subject changed from Error accessing default template when trying to disable build mode with a normal user to Error when trying to disable build

mode with a normal user

- Category deleted (Organizations and Locations)

Fixed, thanks Dominic.

Not sure if this is a bug or not, but I would have expected that a user would have been able to disable build on a host "out of the box".

#10 - 02/24/2016 06:28 AM - Julien Pivotto

- Subject changed from Error when trying to disable build mode with a normal user to Error accessing default template when trying to disable build

mode with a normal user

- Category set to Organizations and Locations

#11 - 02/24/2016 06:35 AM - Dominic Cleal

No problem.  It's definitely a bug, the user shouldn't need direct permissions to view those templates as they're hard-coded.  It can probably be fixed

just by using ProvisioningTemplate.unscoped over at 

https://github.com/theforeman/foreman/blob/1.10.2/app/models/concerns/orchestration/tftp.rb#L48-L50 which will avoid orgs/locs entirely.

The code should probably be more defensive if they're missing so as not to get the 'encoding' related error, e.g. 

https://github.com/theforeman/foreman/blob/1.10.2/app/models/provisioning_template.rb#L116

Files

production.log 15.8 KB 02/24/2016 Julien Pivotto
